<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface AddressInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface AddressInterface
{
    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_STREET,
        self::KEY_POSTAL_CODE,
        self::KEY_PROVINCE,
        self::KEY_CITY,
        self::KEY_COUNTRY
    ];

    /**
     * Properties
     */
    const KEY_STREET = 'street';
    const KEY_POSTAL_CODE = 'postalCode';
    const KEY_PROVINCE = 'province';
    const KEY_CITY = 'city';
    const KEY_COUNTRY = 'country';

    /**
     * @return mixed
     */
    public function getStreet();

    /**
     * @param $street
     * @return mixed
     */
    public function setStreet($street);

    /**
     * @return mixed
     */
    public function getPostalCode();

    /**
     * @param $postalCode
     * @return mixed
     */
    public function setPostalCode($postalCode);

    /**
     * @return mixed
     */
    public function getProvince();

    /**
     * @param $province
     * @return mixed
     */
    public function setProvince($province);

    /**
     * @return mixed
     */
    public function getCity();

    /**
     * @param $city
     * @return mixed
     */
    public function setCity($city);

    /**
     * @return mixed
     */
    public function getCountry();

    /**
     * @param $country
     * @return mixed
     */
    public function setCountry($country);

}
