<?php


namespace Instant\Credit\Api\Data;

/**
 * Interface CartItemInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface CartItemInterface
{
    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_CATEGORY,
    ];

    /**
     * Properties
     */
    const KEY_CATEGORY = 'category';
    const KEY_UNITS = 'units';
    const KEY_DESCRIPTION = 'description';
    const KEY_BRAND = 'brand';
    const KEY_SUBCATEGORY = 'subcategory';
    const KEY_AMOUNT = 'amount';
    const KEY_CURRENCY = 'currency';
    const KEY_PRODUCT_CONDITION = 'productcondition';
    const KEY_KEY = 'key';
    const KEY_VALUE = 'value';


    /**
     * @param string $key
     * @return mixed
     */
    public function setKey(string $key);

    /**
     * @param string $value
     * @return mixed
     */
    public function setValue(string $value);

    /**
     * @param string $category
     * @return mixed
     */
    public function setCategory(string $category);

    /**
     * @param int $units
     * @return mixed
     */
    public function setUnits(int $units);

    /**
     * @param string $brand
     * @return mixed
     */
    public function setBrand(string $brand);

    /**
     * @param string $description
     * @return mixed
     */
    public function setDescription(string $description);

    /**
     * @param string $subcategory
     * @return mixed
     */
    public function setSubcategory(string $subcategory);

    /**
     * @param string $amount
     * @return mixed
     */
    public function setAmount(string $amount);

    /**
     * @param string $currency
     * @return mixed
     */
    public function setCurrency(string $currency);

    /**
     * @param string $productCondition
     * @return mixed
     */
    public function setProductCondition(string $productCondition);

}
