<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface CreditConfirmationInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface CreditConfirmationInterface extends \Instant\Credit\Api\Data\RequestInterface
{
    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        'transactionId',
        'orderId',
        'result',
        'resultType',
        'resultDescription'
    ];

    /**
     * Properties
     */
    const KEY_TRANSACTION_ID = 'transactionId';
    const KEY_ORDER_ID = 'orderId';
    const KEY_RESULT = 'result';
    const KEY_RESULT_TYPE = 'resultType';
    const KEY_RESULT_DESCRIPTION = 'resultDescription';

    /**
     * @return mixed
     */
    public function getTransactionId();

    /**
     * @param $transactionId
     * @return mixed
     */
    public function setTransactionId($transactionId);

    /**
     * @return mixed
     */
    public function getOrderId();

    /**
     * @param $orderId
     * @return mixed
     */
    public function setOrderId($orderId);

    /**
     * @return mixed
     */
    public function getResult();

    /**
     * @param $result
     * @return mixed
     */
    public function setResult($result);

    /**
     * @return mixed
     */
    public function getResultType();

    /**
     * @param $resultType
     * @return mixed
     */
    public function setResultType($resultType);

    /**
     * @return mixed
     */
    public function getResultDescription();

    /**
     * @param $resultDescription
     * @return mixed
     */
    public function setResultDescription($resultDescription);

}
