<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface CreditInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface CreditInterface extends \Instant\Credit\Api\Data\RequestInterface
{

    const API_ENDPOINT = 'credit/request';

    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_ORDER_ID,
        self::KEY_CUSTOM,
        self::KEY_AMOUNT,
        self::KEY_CURRENCY,
        self::KEY_COUNTRY,
        self::KEY_SUCCESS_URL,
        self::KEY_FAIL_URL,
        self::KEY_NOTIFICATION_URL,
        self::KEY_END_USER
    ];

    /**
     * Properties
     */
    const KEY_ORDER_ID = 'orderId';
    const KEY_CUSTOM = 'custom';
    const KEY_AMOUNT = 'amount';
    const KEY_CURRENCY = 'currency';
    const KEY_COUNTRY = 'country';
    const KEY_SUCCESS_URL = 'successURL';
    const KEY_FAIL_URL = 'failURL';
    const KEY_NOTIFICATION_URL = 'notificationURL';
    const KEY_WHITE_LIST = 'whiteList';
    const KEY_BLACK_LIST = 'blackList';
    const KEY_END_USER = 'endUser';
    const KEY_CART = 'cart';

    /**
     * @return mixed
     */
    public function getOrderId();

    /**
     * @param $orderId
     * @return mixed
     */
    public function setOrderId($orderId);

    /**
     * @return mixed
     */
    public function getCustom();

    /**
     * @param $custom
     * @return mixed
     */
    public function setCustom($custom);

    /**
     * @return mixed
     */
    public function getAmount();

    /**
     * @param $amount
     * @return mixed
     */
    public function setAmount($amount);

    /**
     * @return mixed
     */
    public function getCurrency();

    /**
     * @param $currency
     * @return mixed
     */
    public function setCurrency($currency);

    /**
     * @return mixed
     */
    public function getCountry();

    /**
     * @param $country
     * @return mixed
     */
    public function setCountry($country);

    /**
     * @return mixed
     */
    public function getSuccessURL();

    /**
     * @param $successURL
     * @return mixed
     */
    public function setSuccessURL($successURL);

    /**
     * @return mixed
     */
    public function getFailURL();

    /**
     * @param $failURL
     * @return mixed
     */
    public function setFailURL($failURL);

    /**
     * @return mixed
     */
    public function getNotificationURL();

    /**
     * @param $notificationURL
     * @return mixed
     */
    public function setNotificationUrl($notificationURL);

    /**
     * @return mixed
     */
    public function getWhiteList();

    /**
     * @param $whiteList
     * @return mixed
     */
    public function setWhiteList($whiteList);

    /**
     * @return mixed
     */
    public function getBlackList();

    /**
     * @param $blackList
     * @return mixed
     */
    public function setBlackList($blackList);

    /**
     * @return mixed
     */
    public function getEndUser();

    /**
     * @param \Instant\Credit\Model\Api\Data\EndUserApi $endUser
     * @return mixed
     */
    public function setEndUser($endUser);

    /**
     * @return \Instant\Credit\Model\Api\Data\CartItemApi[]
     */
    public function getCart();

    /**
     * @param \Instant\Credit\Model\Api\Data\CartItemApi[] $cart
     * @return mixed
     */
    public function setCart(array $cart);

}
