<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface EndUserInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface EndUserInterface
{
    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_END_USER_ID,
        self::KEY_FIRST_NAME,
        self::KEY_LAST_NAME,
        self::KEY_PERSONAL_ID,
        self::KEY_EMAIL,
        self::KEY_BIRTH_DATE,
        self::KEY_MOBILE,
        self::KEY_ADDRESS,
        self::KEY_REGISTRATION_DATE,
        self::KEY_IP,
        self::KEY_ALTERNATIVE_PHONE_NUMBER
    ];

    /**
     * Properties
     */
    const KEY_END_USER_ID = 'endUserId';
    const KEY_FIRST_NAME = 'firstName';
    const KEY_LAST_NAME = 'lastName';
    const KEY_PERSONAL_ID = 'personalId';
    const KEY_EMAIL = 'email';
    const KEY_BIRTH_DATE = 'birthDate';
    const KEY_MOBILE = 'mobile';
    const KEY_ADDRESS = 'address';
    const KEY_REGISTRATION_DATE = 'registrationDate';
    const KEY_IP = 'ip';
    const KEY_ALTERNATIVE_PHONE_NUMBER = 'alternativePhoneNumber';
    const KEY_HISTORIC_ORDERS = 'historicOrders';

    /**
     * @return mixed
     */
    public function getEndUserId();

    /**
     * @param $endUserId
     * @return mixed
     */
    public function setEndUserId($endUserId);

    /**
     * @return mixed
     */
    public function getFirstName();

    /**
     * @param $firstName
     * @return mixed
     */
    public function setFirstName($firstName);

    /**
     * @return mixed
     */
    public function getLastName();

    /**
     * @param $lastName
     * @return mixed
     */
    public function setLastName($lastName);

    /**
     * @return mixed
     */
    public function getPersonalId();

    /**
     * @param $personalId
     * @return mixed
     */
    public function setPersonalId($personalId);

    /**
     * @return mixed
     */
    public function getEmail();

    /**
     * @param $email
     * @return mixed
     */
    public function setEmail($email);

    /**
     * @return mixed
     */
    public function getBirthDate();

    /**
     * @param $birthDate
     * @return mixed
     */
    public function setBirthDate($birthDate);

    /**
     * @return mixed
     */
    public function getMobile();

    /**
     * @param $mobile
     * @return mixed
     */
    public function setMobile($mobile);

    /**
     * @return mixed
     */
    public function getAddress();

    /**
     * @param $address
     * @return mixed
     */
    public function setAddress($address);

    /**
     * @return mixed
     */
    public function getRegistrationDate();

    /**
     * @param $registrationDate
     * @return mixed
     */
    public function setRegistrationDate($registrationDate);

    /**
     * @return mixed
     */
    public function getIp();

    /**
     * @param $ip
     * @return mixed
     */
    public function setIp($ip);

    /**
     * @return mixed
     */
    public function getAlernativePhoneNumber();

    /**
     * @param $phoneNumber
     * @return mixed
     */
    public function setAlternativePhoneNumber($phoneNumber);

    /**
     * @return mixed
     */
    public function getHistoricOrders();

    /**
     * @param $historicOrders
     * @return mixed
     */
    public function setHistoricOrders($historicOrders);

}
