<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface RefundInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface RefundInterface extends \Instant\Credit\Api\Data\RequestInterface
{

    const API_ENDPOINT = 'refund/request';

    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_ORDER_ID,
        self::KEY_REFUND_ID,
        self::KEY_AMOUNT,
        self::KEY_CURRENCY,
        self::KEY_COUNTRY
    ];

    /**
     * Properties
     */
    const KEY_ORDER_ID = 'orderId';
    const KEY_REFUND_ID = 'refundId';
    const KEY_AMOUNT = 'amount';
    const KEY_CURRENCY = 'currency';
    const KEY_COUNTRY = 'country';

    /**
     * @return mixed
     */
    public function getOrderId();

    /**
     * @param $orderId
     * @return mixed
     */
    public function setOrderId($orderId);

    /**
     * @return mixed
     */
    public function getRefundId();

    /**
     * @param $refundId
     * @return mixed
     */
    public function setRefundId($refundId);

    /**
     * @return mixed
     */
    public function getAmount();

    /**
     * @param $amount
     * @return mixed
     */
    public function setAmount($amount);

    /**
     * @return mixed
     */
    public function getCurrency();

    /**
     * @param $currency
     * @return mixed
     */
    public function setCurrency($currency);

    /**
     * @return mixed
     */
    public function getCountry();

    /**
     * @param $country
     * @return mixed
     */
    public function setCountry($country);

}
