<?php

namespace Instant\Credit\Api\Data;

/**
 * Interface TokenInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface TokenInterface extends \Instant\Credit\Api\Data\RequestInterface
{

    const API_ENDPOINT = 'oauth/token';

    /**
     * Required params
     */
    const REQUIRED_PARAMS = [
        self::KEY_CLIENT_ID,
        self::KEY_USERNAME,
        self::KEY_PASSWORD,
        self::KEY_GRANT_TYPE
    ];

    /**
     * Properties
     */
    const KEY_CLIENT_ID = 'clientId';
    const KEY_USERNAME = 'userName';
    const KEY_PASSWORD = 'password';
    const KEY_GRANT_TYPE = 'grantType';
    const KEY_SCOPE = 'scope';

    /**
     * @return mixed
     */
    public function getClientId();

    /**
     * @param $clientId
     * @return mixed
     */
    public function setClientId($clientId);

    /**
     * @return mixed
     */
    public function getUsername();

    /**
     * @param $username
     * @return mixed
     */
    public function setUsername($username);

    /**
     * @return mixed
     */
    public function getPassword();

    /**
     * @param $password
     * @return mixed
     */
    public function setPassword($password);

    /**
     * @return mixed
     */
    public function getGrantType();

    /**
     * @param $grantType
     * @return mixed
     */
    public function setGrantType($grantType);

    /**
     * @return mixed
     */
    public function getScope();

    /**
     * @param $scope
     * @return mixed
     */
    public function setScope($scope);

}
