<?php

namespace Instant\Credit\Api\Data;

use Magento\Framework\Api\CustomAttributesDataInterface;

/**
 * Interface TransactionsInterface
 * @package Instant\Credit\Api\Data
 * @author Orenyi
 */
interface TransactionsInterface extends CustomAttributesDataInterface
{
    /**
     * Table
     */
    const TABLE         = 'instantcredit_transactions';

    /**
     * Columns
     */
    const ENTITY_ID     = 'entity_id';
    const ID            = 'transactions_id';
    const ORDER_ID      = 'order_id';
    const CUSTOM        = 'custom';
    const RESULT        = 'result';
    const RESULT_TYPE   = 'result_type';
    const COUNTRY       = 'country';
    const AMOUNT        = 'amount';
    const CURRENCY      = 'currency';
    const SIGNATURE     = 'signature';
    const CONFIRMED     = 'confirmed';
    const DESCRIPTION   = 'description';
    const CREATED_AT    = 'created_at';
    const UPDATED_AT    = 'updated_at';

    /**
     * @return mixed
     */
    public function getTransactionId();

    /**
     * @return mixed
     */
    public function getOrderId();

    /**
     * @return mixed
     */
    public function getCustom();

    /**
     * @return mixed
     */
    public function getResult();

    /**
     * @return mixed
     */
    public function getResultType();

    /**
     * @return mixed
     */
    public function getCountry();

    /**
     * @return mixed
     */
    public function getAmount();

    /**
     * @return mixed
     */
    public function getCurrency();

    /**
     * @return mixed
     */
    public function getSignature();

    /**
     * @return mixed
     */
    public function getConfirmed();

    /**
     * @return mixed
     */
    public function getDescription();

    /**
     * @return mixed
     */
    public function getCreatedAt();

    /**
     * @return mixed
     */
    public function getUpdatedAt();

    /**
     * @param int $transactionId
     * @return mixed
     */
    public function setTransactionId(int $transactionId);

    /**
     * @param int $orderId
     * @return mixed
     */
    public function setOrderId(string $orderId);

    /**
     * @param string $custom
     * @return mixed
     */
    public function setCustom(string $custom);

    /**
     * @param string $result
     * @return mixed
     */
    public function setResult(string $result);

    /**
     * @param string $resultType
     * @return mixed
     */
    public function setResultType(string $resultType);

    /**
     * @param string $country
     * @return mixed
     */
    public function setCountry(string $country);

    /**
     * @param float $amount
     * @return mixed
     */
    public function setAmount(float $amount);

    /**
     * @param string $currency
     * @return mixed
     */
    public function setCurrency(string $currency);

    /**
     * @param string $signature
     * @return mixed
     */
    public function setSignature(string $signature);

    /**
     * @param bool $confirmed
     * @return mixed
     */
    public function setConfirmed(bool $confirmed);

    /**
     * @param string $description
     * @return mixed
     */
    public function setDescription(string $description);
}