<?php

namespace Instant\Credit\Model\Api\Data;

/**
 * Class CartItemApi
 * @package Instant\Credit\Model\Api\Data
 * @author Orenyi
 */
class CartItemApi extends \Magento\Framework\DataObject implements \Instant\Credit\Api\Data\CartItemInterface
{

    /**
     * @param string $category
     * @return mixed
     */
    public function setCategory(string $category)
    {
        return $this->setData(self::KEY_CATEGORY, $category);
    }

    /**
     * @param string $subcategory
     * @return mixed
     */
    public function setSubcategory(string $subcategory)
    {
        return $this->setData(self::KEY_SUBCATEGORY, $subcategory);
    }

    /**
     * @param string $amount
     * @return mixed
     */
    public function setAmount(string $amount)
    {
        return $this->setData(self::KEY_AMOUNT, $amount);
    }

    /**
     * @param string $currency
     * @return mixed
     */
    public function setCurrency(string $currency)
    {
        return $this->setData(self::KEY_CURRENCY, $currency);
    }

    /**
     * @param int $units
     * @return mixed
     */
    public function setUnits(int $units)
    {
        return $this->setData(self::KEY_UNITS, $units);
    }

    /**
     * @param string $brand
     * @return mixed
     */
    public function setBrand(string $brand)
    {
        return $this->setData(self::KEY_BRAND, $brand);
    }

    /**
     * @param string $description
     * @return mixed
     */
    public function setDescription(string $description)
    {
        return $this->setData(self::KEY_DESCRIPTION, $description);
    }

    /**
     * @param string $productCondition
     * @return mixed
     */
    public function setProductCondition(string $productCondition)
    {
        return $this->setData(self::KEY_PRODUCT_CONDITION, $productCondition);
    }

    /**
     * @param string $key
     * @return mixed
     */
    public function setKey(string $key)
    {
        return $this->setData(self::KEY_KEY, $key);
    }

    /**
     * @param string $value
     * @return mixed
     */
    public function setValue(string $value)
    {
        return $this->setData(self::KEY_VALUE, $value);
    }


}
