<?php

namespace Instant\Credit\Model\Api\Data;

/**
 * Class CreditApi
 * @package Instant\Credit\Model\Api\Data
 * @author Orenyi
 */
class CreditApi extends \Magento\Framework\DataObject implements \Instant\Credit\Api\Data\CreditInterface
{
    /**
     * @return mixed
     */
    public function getOrderId()
    {
        return $this->getData(self::KEY_ORDER_ID);
    }

    /**
     * @param $orderId
     * @return mixed
     */
    public function setOrderId($orderId)
    {
        return $this->setData(self::KEY_ORDER_ID, $orderId);
    }

    /**
     * @return mixed
     */
    public function getCustom()
    {
        return $this->getData(self::KEY_CUSTOM);
    }

    /**
     * @param $custom
     * @return mixed
     */
    public function setCustom($custom)
    {
        return $this->setData(self::KEY_CUSTOM, $custom);
    }

    /**
     * @return mixed
     */
    public function getAmount()
    {
        return $this->getData(self::KEY_AMOUNT);
    }

    /**
     * @param $amount
     * @return mixed
     */
    public function setAmount($amount)
    {
        return $this->setData(self::KEY_AMOUNT, $amount);
    }

    /**
     * @return mixed
     */
    public function getCurrency()
    {
        return $this->getData(self::KEY_CURRENCY);
    }

    /**
     * @param $currency
     * @return mixed
     */
    public function setCurrency($currency)
    {
        return $this->setData(self::KEY_CURRENCY, $currency);
    }

    /**
     * @return mixed
     */
    public function getCountry()
    {
        return $this->getData(self::KEY_COUNTRY);
    }

    /**
     * @param $country
     * @return mixed
     */
    public function setCountry($country)
    {
        return $this->setData(self::KEY_COUNTRY, $country);
    }

    /**
     * @return mixed
     */
    public function getSuccessURL()
    {
        return $this->getData(self::KEY_SUCCESS_URL);
    }

    /**
     * @param $successURL
     * @return mixed
     */
    public function setSuccessURL($successURL)
    {
        return $this->setData(self::KEY_SUCCESS_URL, $successURL);
    }

    /**
     * @return mixed
     */
    public function getFailURL()
    {
        return $this->getData(self::KEY_FAIL_URL);
    }

    /**
     * @param $failURL
     * @return mixed
     */
    public function setFailURL($failURL)
    {
        return $this->setData(self::KEY_FAIL_URL, $failURL);
    }

    /**
     * @return mixed
     */
    public function getNotificationURL()
    {
        return $this->getData(self::KEY_NOTIFICATION_URL);
    }

    /**
     * @param $notificationURL
     * @return mixed
     */
    public function setNotificationUrl($notificationURL)
    {
        return $this->setData(self::KEY_NOTIFICATION_URL, $notificationURL);
    }

    /**
     * @return mixed
     */
    public function getWhiteList()
    {
        return $this->getData(self::KEY_WHITE_LIST);
    }

    /**
     * @param $whiteList
     * @return mixed
     */
    public function setWhiteList($whiteList)
    {
        return $this->setData(self::KEY_WHITE_LIST, $whiteList);
    }

    /**
     * @return mixed
     */
    public function getBlackList()
    {
        return $this->getData(self::KEY_BLACK_LIST);
    }

    /**
     * @param $blackList
     * @return mixed
     */
    public function setBlackList($blackList)
    {
        return $this->setData(self::KEY_BLACK_LIST, $blackList);
    }

    /**
     * @return mixed
     */
    public function getEndUser()
    {
        return $this->getData(self::KEY_END_USER);
    }

    /**
     * @param \Instant\Credit\Model\Api\Data\EndUserApi $endUser
     * @return mixed
     */
    public function setEndUser($endUser)
    {
        return $this->setData(self::KEY_END_USER, $endUser);
    }

    /**
     * @return \Instant\Credit\Model\Api\Data\CartItemApi[]
     */
    public function getCart()
    {
        return $this->getData(self::KEY_CART);
    }

    /**
     * @param \Instant\Credit\Model\Api\Data\CartItemApi[] $cart
     * @return mixed
     */
    public function setCart(array $cart)
    {
        return $this->setData(self::KEY_CART, $cart);
    }

}
