<?php

namespace Instant\Credit\Model\Api;

/**
 * Class RequestApi
 * @package Instant\Credit\Model\Api
 * @author Orenyi
 */
class RequestApi extends \Instant\Credit\Api\AbstractApi implements \Instant\Credit\Api\RequestInterface
{
    /**
     * @param \Instant\Credit\Api\Data\RequestInterface $request
     * @return mixed
     * @throws \Instant\Credit\Api\ApiException
     */
    public function doRequest(\Instant\Credit\Api\Data\RequestInterface $request)
    {
        /** @var array $data */
        $data = $this->objectToArray($request);

        $this->checkBodyParameters($request::REQUIRED_PARAMS, $data);

        return $this->request($request::API_ENDPOINT, $data);
    }

    /**
     * Convert object to array recursively
     * @param $object
     * @return array
     */
    public function objectToArray($object)
    {
        if (!is_object($object) && !is_array($object)) {
            return $object;
        }

        $data = $object;
        if (is_object($object)) {
            $data = $object->getData();
        }

        return array_map([$this, 'objectToArray'], $data);
    }
}
