<?php

namespace Instant\Credit\Plugin;

/**
 * Class OrderPlacePlugin
 * @package Instant\Credit\Plugin
 * @author Orenyi
 */
class OrderPlacePlugin
{
    /**
     * @var \Magento\Sales\Api\OrderRepositoryInterface
     */
    private $orderRepository;

    /**
     * OrderPlacePlugin constructor.
     * @param \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
     */
    public function __construct(
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository
    ) {

        $this->orderRepository = $orderRepository;
    }

    /**
     * @param \Magento\Sales\Model\Service\OrderService $subject
     * @param \Magento\Sales\Api\Data\OrderInterface $order
     * @param callable $proceed
     * @return \Magento\Sales\Api\Data\OrderInterface
     */
    public function aroundPlace(
        \Magento\Sales\Model\Service\OrderService $subject,
        callable $proceed,
        \Magento\Sales\Api\Data\OrderInterface $order
    ) {
        $method = $order->getPayment()->getMethod();

        $isInstantCredit = $method === \Instant\Credit\Model\InstantCreditMethod::INSTANTCREDIT_METHOD;
        // If is Instant Credit method, we disable sending order mail
        if ($isInstantCredit) {
            $order->setCanSendNewEmailFlag(false);
            $this->orderRepository->save($order);
        }

        /** @var \Magento\Sales\Api\Data\OrderInterface $order */
        $order = $proceed($order);

        return $order;
    }


}