define(
    [
        'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/action/redirect-on-success',
        'mage/url',
    ],
    function ($, Component, quote, redirectOnSuccessAction, url) {
        'use strict';

        return Component.extend({
            defaults: {
                template: 'Instant_Credit/payment/instantcredit'
            },

            getTotalPrice: function()
            {
                let totals = quote.totals();
                return totals.base_grand_total;
            },

            getTotalPriceFormatted: function()
            {
                let amountValue = this.getTotalPrice();
                let valSimulator = amountValue.toString().replace('.', ',');
                if (parseFloat(amountValue) === parseInt(amountValue)) {
                    valSimulator = parseFloat(amountValue) + ',00';
                }

                return valSimulator;
            },

            initializeICSimulator: function()
            {
                if (typeof icSimulator !== 'undefined') {
                    icSimulator.initialize();
                }
            },
            afterPlaceOrder: function () {
                redirectOnSuccessAction.redirectUrl = url.build('instantcredit/redirect/');
                this.redirectAfterPlaceOrder = true;
            },
            updateSimulator: function(){
                let amountValue = this.getTotalPrice();
                let valSimulator = amountValue.toString().replace('.', ',');
                if (parseFloat(amountValue) === parseInt(amountValue)) {
                    valSimulator = parseFloat(amountValue) + ',00';
                }
                let classSimulator = '.ic-simulator';
                console.log($(classSimulator));
                if (typeof icSimulator !== 'undefined' && $(classSimulator).length > 0) {
                    $(classSimulator).empty();
                    $(classSimulator).attr('amount', valSimulator);
                    $(classSimulator).attr('comma');
                    icSimulator.initialize();   
                }
                
                return valSimulator;
            }

        });
    }
);